﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;

namespace TestCS
{
    public enum MyEnum
    {
        ERR_OK = 0,         //成功
        ERR_CONNECT = -1,   //连接失败
        ERR_HANDLE = -2,    //句柄
        ERR_TYPE = -3,      //元件类型
        ERR_NUM = -4,       //数量越界
        ERR_SKT = -5,
        ERR_REV = -6,
    }
   public class YKApi
    {
        //获得版本
        /// <summary>
        /// 连接ProH
        /// </summary>
        /// <param IP地址="ip_addr"></param>
        /// <param 端口号="ip_port"></param>
        /// <returns></returns>
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int GetVer();

        //YKApi的连接与关闭
        /// <summary>
        /// 连接ProH
        /// </summary>
        /// <param IP地址="ip_addr"></param>
        /// <param 端口号="ip_port"></param>
        /// <returns></returns>
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int Connect(char[] ip_addr, int ip_port);

        /// <summary>
        /// 关闭通道
        /// </summary>
        /// <param  Connect函数返回的句柄="handle"></param>
        /// <returns></returns>
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int Close(int handle);

        /// <summary>
        /// /
        /// </summary>
        /// <param Connect函数返回的句柄="handle"></param>
        /// <param 读取或写入元件的起始="index"></param>
        /// <param 读取或写入元件的数量="num"></param>
        /// <param 读取或写入元件的数据="data"></param>
        /// <returns></returns>
        //T计时器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordT(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordT(int handle, uint index, uint num, ushort[] data);

        //C计数器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordC16(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordC16(int handle, uint index, uint num, ushort[] data);

        //C高速计数器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordC32(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordC32(int handle, uint index, uint num, ushort[] data);

        //D寄存器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordD(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordD(int handle, uint index, uint num, ushort[] data);

        //SD寄存器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordSD(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordSD(int handle, uint index, uint num, ushort[] data);

        //R寄存器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordR(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordR(int handle, uint index, uint num, ushort[] data);

        //RD寄存器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordRD(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordRD(int handle, uint index, uint num, ushort[] data);

        //VD寄存器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteWordVD(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadWordVD(int handle, uint index, uint num, ushort[] data);



        /// <summary>
        /// 
        /// </summary>
        /// <param Connect函数返回的句柄="handle"></param>
        /// <param 读取或写入元件的起始="index"></param>
        /// <param 读取或写入元件的数量="num"></param>
        /// <param 读取或写入元件的数据="data"></param>
        /// <returns></returns>
        //X输入继电器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitX(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitX(int handle, uint index, uint num, ushort[] data);

        //Y输出继电器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitY(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitY(int handle, uint index, uint num, ushort[] data);

        //M辅助继电器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitM(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitM(int handle, uint index, uint num, ushort[] data);

        //SM继电器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitSM(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitSM(int handle, uint index, uint num, ushort[] data);

        //S状态继电器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitS(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitS(int handle, uint index, uint num, ushort[] data);


        //B继电器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitB(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitB(int handle, uint index, uint num, ushort[] data);

        //L继电器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitL(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitL(int handle, uint index, uint num, ushort[] data);

        //F继电器元件读写
        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WriteBitF(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ReadBitF(int handle, uint index, uint num, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum FloatToWordT(float fv, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WordToFloatT(ushort[] word, ref float fv);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum IntToWordT(int iv, ushort[] data);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WordToIntT(ushort[] word, ref int iv);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum WordToByteT(ushort[] word, byte[] iv);

        [DllImport("YKApi.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern MyEnum ByteToWordT(byte[] iv, ushort[] data);

    }
}
